;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; PROGRAMMING FUNDAMENTALS I - 2004
; MICHELE LANZA - FACULTY OF INFORMATICS - UNIVERSITY OF LUGANO, SWITZERLAND
; LECTURE 7 - ITERATIVE REFINEMENT AND LEXICAL SCOPE
; PROCESSING TWO LISTS SIMULTANEOUSLY

; DATA ANALYSIS AND DESIGN

; a list-of-symbols is
; 1. empty
; 2. (cons s l-o-s) where s is a symbol and l-o-s is a list of symbols
; EXAMPLES
(define list1 '(a b c))

; a list-of-numbers is
; 1. empty
; 2. (cons n l-o-n) where n is a number and l-o-n is a list of numbers
; EXAMPLES
(define list2 (list 1 2))

; AUXILIARY FUNCTION
; make-sub-cross : symbol list -> list
; takes a symbol and a list and produces all cross-products as lists
(define make-sub-cross
  (lambda (a-symbol a-list)
    (cond
      [(empty? a-list) empty]
      [else (cons (list a-symbol (first a-list)) (make-sub-cross a-symbol (rest a-list)))])))

; TEMPLATE
; (define foo-with-lists
; (lambda (a-list another-list)
; (cond
; [(empty? a-list) ..]
; [else ..(first a-list).. ..(foo-with-lists (rest a-list) another-list)..]

; cross: list list -> list
; takes two lists of symbols and numbers and produces a list of all lists with the crossproducts
(define cross
  (lambda (list1 list2)
    (cond
      [(empty? list1) empty]
      [else (cons (make-sub-cross (first list1) list2) (cross (rest list1) list2))])))

; TESTS
(equal? (cross list1 list2) 
        (list (list (list 'a 1) (list 'a 2)) (list (list 'b 1) (list 'b 2)) (list (list 'c 1) (list 'c 2))))

; hours->wages : list list -> list
; constructs a list of wages based on the number of hours worked and the respective employee rates
; ASSUMPTION: the two lists have the same length!
(define hours->wages
  (lambda (a-list-of-hours a-list-of-rates)
    (cond
      [(empty? a-list-of-hours) empty]
      [else (cons (* (first a-list-of-hours) (first a-list-of-rates)) 
                  (hours->wages (rest a-list-of-hours) (rest a-list-of-rates)))])))